/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

int LEN = 10;
int main(int argc, char **argv)
{
  int __retres;
  unsigned long __lengthof_arr;
  int i;
  __e_acsl_memory_init(& argc,& argv,(size_t)8);
  {
    int __gen_e_acsl_and;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"sizeof(int)",0,
                                 4);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"LEN",0,LEN);
    if (0L < 4L * LEN) {
      __e_acsl_mpz_t __gen_e_acsl_;
      __e_acsl_mpz_t __gen_e_acsl__2;
      int __gen_e_acsl_le;
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"sizeof(int)",
                                   0,4);
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"LEN",0,LEN);
      __gmpz_init_set_si(__gen_e_acsl_,4L * LEN);
      __gmpz_init_set_ui(__gen_e_acsl__2,18446744073709551615UL);
      __gen_e_acsl_le = __gmpz_cmp((__e_acsl_mpz_struct const *)(__gen_e_acsl_),
                                   (__e_acsl_mpz_struct const *)(__gen_e_acsl__2));
      __gen_e_acsl_and = __gen_e_acsl_le <= 0;
      __gmpz_clear(__gen_e_acsl_);
      __gmpz_clear(__gen_e_acsl__2);
    }
    else __gen_e_acsl_and = 0;
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "alloca_bounds: 0 < sizeof(int) * LEN <= 18446744073709551615";
    __gen_e_acsl_assert_data.file = "tests/memory/vla.c";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 9;
    __e_acsl_assert(__gen_e_acsl_and,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert alloca_bounds: 0 < sizeof(int) * LEN <= 18446744073709551615; */
  ;
  __lengthof_arr = (unsigned long)LEN;
  int *arr = __builtin_alloca(sizeof(int) * __lengthof_arr);
  __e_acsl_store_block((void *)arr,sizeof(int) * __lengthof_arr);
  __e_acsl_store_block((void *)(& arr),(size_t)8);
  __e_acsl_full_init((void *)(& arr));
  i = 0;
  while (i <= LEN) {
    if (i < LEN) {
      {
        int __gen_e_acsl_valid;
        __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
          {.values = (void *)0};
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"arr",
                                     (void *)arr);
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,"i",0,i);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                       "sizeof(int)",0,sizeof(int));
        __gen_e_acsl_valid = __e_acsl_valid((void *)(arr + i),sizeof(int),
                                            (void *)arr,(void *)(& arr));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                     "\\valid(arr + i)",0,__gen_e_acsl_valid);
        __gen_e_acsl_assert_data_2.blocking = 1;
        __gen_e_acsl_assert_data_2.kind = "Assertion";
        __gen_e_acsl_assert_data_2.pred_txt = "\\valid(arr + i)";
        __gen_e_acsl_assert_data_2.file = "tests/memory/vla.c";
        __gen_e_acsl_assert_data_2.fct = "main";
        __gen_e_acsl_assert_data_2.line = 13;
        __e_acsl_assert(__gen_e_acsl_valid,& __gen_e_acsl_assert_data_2);
        __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
      }
      /*@ assert \valid(arr + i); */ ;
    }
    else {
      {
        int __gen_e_acsl_valid_2;
        __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
          {.values = (void *)0};
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"arr",
                                     (void *)arr);
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,"i",0,i);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                       "sizeof(int)",0,sizeof(int));
        __gen_e_acsl_valid_2 = __e_acsl_valid((void *)(arr + i),sizeof(int),
                                              (void *)arr,(void *)(& arr));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                     "\\valid(arr + i)",0,
                                     __gen_e_acsl_valid_2);
        __gen_e_acsl_assert_data_3.blocking = 1;
        __gen_e_acsl_assert_data_3.kind = "Assertion";
        __gen_e_acsl_assert_data_3.pred_txt = "!\\valid(arr + i)";
        __gen_e_acsl_assert_data_3.file = "tests/memory/vla.c";
        __gen_e_acsl_assert_data_3.fct = "main";
        __gen_e_acsl_assert_data_3.line = 15;
        __e_acsl_assert(! __gen_e_acsl_valid_2,& __gen_e_acsl_assert_data_3);
        __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
      }
      /*@ assert !\valid(arr + i); */ ;
    }
    i ++;
  }
  __retres = 0;
  __e_acsl_delete_block((void *)arr);
  /* __fc_vla_free((void *)arr); */
  __e_acsl_delete_block((void *)(& arr));
  __e_acsl_memory_clean();
  return __retres;
}


